;*********************************************************************************************************
;***************  Anzeigeroutinen zum Tapetimer Version 1.0 vom 13.10.2014 Stefan Kneller	**********
;*********************************************************************************************************

;*********************************************************************************************************
;***************  Anzeigespeicher lschen							**********
;***************  benutzte Register: temp, digit[5:1]						**********
;*********************************************************************************************************
loesche_digits:
	clr	temp			;
	sts	digit1,temp		;
	sts	digit2,temp		;
	sts	digit3,temp		;
	sts	digit4,temp		;
	sts	digit5,temp		;
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "STUNDEN:MINUTEN:SEKUNDEN" in Anzeigespeicher schreiben		**********
;***************  benutzte Register:								**********
;***************     temp[3:0], digit[5:1], dp_stelle, blinker, tBCD[2:0], Z			**********
;*********************************************************************************************************
zeige_zeit:
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_minuten_symb	;kurz einen Kennbuchstaben zeigen
.if (anzeigestellen==4)			;nur bei 4 Digits
	ldi	temp,(1<<3)		;Dezimalpunkt als Trenner eintasten
.else
	ldi	temp,(1<<1)|(1<<3)	;sonst 2 Dezimalpunkte als Trenner eintasten
.endif
	sts	dp_stelle,temp		;
	lds	temp,Zeit_anz_l		;hole quarzgenaue Sekundenlaufzeit
	lds	temp1,Zeit_anz_h	;
	rcall	sek2min2BCD		;wandle ins Format Std/Min/Sek bzw Min/Sek und lege als gepacktes BCD ab
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ret				;
zeige_minuten_symb:
	rcall	loesche_digits		;Anzeige lschen
	sts	dp_stelle,temp		;auch den Dezimalpuznkt
	ldi	temp,zeichen_t_kl	;
.if (anzeigestellen==4)			;nur bei 4 Digits
	sts	digit2,temp		;
.else					;nur bei 5 Digits
	sts	digit1,temp		;
.endif
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "U UMDREHUNGEN" in Anzeigespeicher schreiben			**********
;***************  benutzte Register:								**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_umdrehungen:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_umdrehung_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,umdreh_l		;hole Umdrehungszhler
	lds	temp1,umdreh_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_u		;	
	sts	digit1,temp		;links noch das Zeichen "U" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_umdrehung_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_u		;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge " BANDDICKE" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: dicke,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_dicke:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_dicke_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<3)		;
	sts	dp_stelle,temp		;Taste Dezimalpunkt ein
	lds	temp,dicke_l		;hole Dickenwert
	lds	temp1,dicke_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_mikro	;	
	sts	digit1,temp		;links noch das Zeichen "" eintasten
.if (anzeigestellen==4)			;nur bei 4 Digits
	ldi	temp,zeichen_u_kl	;	
	sts	digit5,temp		;rechts noch das Zeichen "u" eintasten
.endif
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_dicke_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_mikro	;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge " BANDDICKE" mit Hundertstelstelle in Anzeigespeicher schreiben	**********
;***************  benutzte Register: dicke,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_dicke_4:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_dicke_4_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<3)		;
	sts	dp_stelle,temp		;Taste Dezimalpunkt ein
	lds	temp,dicke_l		;hole Dickenwert
	lds	temp1,dicke_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_mikro	;	
	sts	digit1,temp		;links noch das Zeichen "" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_dicke_4_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_mikro	;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "h KOPFSTUNDEN" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: hour,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_kopfstunden:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_stunden_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,hour_l		;lade Stundenzhler
	lds	temp1,hour_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_h_kl		;	
	sts	digit1,temp		;links noch das Zeichen "h" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_stunden_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_h_kl	;lade Kennbuchstaben h und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "r WICKELRADIUS" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: radius,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_radius:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_radius_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<3)		;
	sts	dp_stelle,temp		;Dezimalpunkt
	lds	temp,radius_l		;lade Wickelradius
	lds	temp1,radius_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_r_kl	;	
	sts	digit1,temp		;links noch das Zeichen "r" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_radius_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_r_kl	;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "L BANDLAGEN" in Anzeigespeicher schreiben			**********
;***************  benutzte Register:	 lagen,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_bandlagen:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_lagen_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,lagen_l		;hole Bandlagenzhler
	lds	temp1,lagen_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_l		;
	sts	digit1,temp		;links noch das Zeichen "L" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_lagen_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_l		;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "A ABWEICHUNG" in Anzeigespeicher schreiben			**********
;***************  Der betragsmige Unterschied in gerechneten Lagen und gezhlten Lagen	**********
;***************  wird mit Vorzeichen angezeigt							**********
;***************  benutzte Register: lagen, umdreh,						**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_abw_lagen:
	cbr	flags,(1<<minus)	;lsche Vorzeichenbit fr Abweichungsanzeige
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_abweichung_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,lagen_l		;hole Lagenzhler
	lds	temp1,lagen_h		;
	lds	temp2,umdreh_l		;hole Umdrehungszhler
	lds	temp3,umdreh_h		;
	sub	temp,temp2		;
	sbc	temp1,temp3		;bilde die Differenz
	brcc	abweichung_ist_positiv	;
	neg	temp			;betragsmig
	com	temp1			;
	sbr	flags,(1<<minus)	;setze Vorzeichenflag "Minus"
abweichung_ist_positiv:
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_A		;
	sts	digit1,temp		;links noch das Zeichen "A" eintasten

	ldi	temp,zeichen_minus	;Minuszeichen laden
	sbrc	flags,minus		;und bei negativem Ergenis
	sts	digit2,temp		;eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_abweichung_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_A		;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "S.SEKUNDEN" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: zeit_calc,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_sekunden:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_sekunden_symb	;kurz einen Kennbuchstaben zeigen
.endif
	clr	temp
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,Zeit_calc_l	;hole errechnete Sekundenlaufzeit
	lds	temp1,Zeit_calc_h	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	sbrs	flags2,synchron		;bis Synchronisierung
	rcall	zeige_ganz_leer		;"----" zeigen
	ldi	temp,zeichen_S_dp	;	
	sts	digit1,temp		;links noch das Zeichen "S." eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_sekunden_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_S_dp	;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "F FEHLER" in Anzeigespeicher schreiben				**********
;***************  Der betragsmige Unterschied in gerechneten und gezhlten Sekunden		**********
;***************  wird mit Vorzeichen angezeigt							**********
;***************  benutzte Register: zeit_calc, zeit_anz,					**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_abw_sekunden:
	cbr	flags,(1<<minus)	;lsche Vorzeichenbit fr Abweichungsanzeige
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_abw_sekunden_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,zeit_calc_l	;hole Lagenzhler
	lds	temp1,zeit_calc_h	;
	lds	temp2,zeit_anz_l	;hole Umdrehungszhler
	lds	temp3,zeit_anz_h	;
	sub	temp,temp2		;
	sbc	temp1,temp3		;bilde die Differenz
	brcc	abw_sekunde_ist_positiv	;
	neg	temp			;betragsmig
	com	temp1			;
	sbr	flags,(1<<minus)	;setze Vorzeichenflag "Minus"
abw_sekunde_ist_positiv:
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_F		;
	sts	digit1,temp		;links noch das Zeichen "A" eintasten

	ldi	temp,zeichen_minus	;Minuszeichen laden
	sbrc	flags,minus		;und bei negativem Ergenis
	sts	digit2,temp		;eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_abw_sekunden_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_F		;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif

;*********************************************************************************************************
;***************  Zeichenfolge "OPEN" in Anzeigespeicher schreiben				**********
;***************  benutzte Register: temp, digit[1:5], dp_stelle				**********
;*********************************************************************************************************
zeige_open:
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	ldi	temp,zeichen_O		;	
	sts	digit2,temp		;das Zeichen "O" eintasten
	ldi	temp,zeichen_P		;	
	sts	digit3,temp		;das Zeichen "P" eintasten
	ldi	temp,zeichen_E		;	
	sts	digit4,temp		;das Zeichen "E" eintasten
	ldi	temp,zeichen_N		;	
	sts	digit5,temp		;das Zeichen "N" eintasten
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "OFFEN" in Anzeigespeicher schreiben				**********
;***************  benutzte Register: temp, digit[1:5], dp_stelle				**********
;*********************************************************************************************************
zeige_offen:
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	ldi	temp,zeichen_O		;	
	sts	digit1,temp		;das Zeichen "O" eintasten
	ldi	temp,zeichen_F		;	
	sts	digit2,temp		;das Zeichen "F" eintasten
	ldi	temp,zeichen_F		;	
	sts	digit3,temp		;das Zeichen "F" eintasten
	ldi	temp,zeichen_E		;	
	sts	digit4,temp		;das Zeichen "E" eintasten
	ldi	temp,zeichen_N		;	
	sts	digit5,temp		;das Zeichen "N" eintasten
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "-----" in Anzeigespeicher schreiben				**********
;***************  benutzte Register: temp, digit[1:5], dp_stelle				**********
;*********************************************************************************************************
zeige_leer:
	ldi	temp,(1<<1)|(1<<3)	;Dezimalpunkt auf Digit 1 und 3
	rjmp	zeige_minus		;und den Rest mit Minuszeichen auffllen
zeige_fast_leer:
	ldi	temp,(1<<3)		;Dezimalpunkt auf Digit 3
	rjmp	zeige_minus		;und den Rest mit Minuszeichen auffllen
zeige_ganz_leer:
	ldi	temp,(1<<0)		;kein Dezimalpunkt
zeige_minus:
	sts	dp_stelle,temp		;
	ldi	temp,zeichen_minus	;	
	sts	digit1,temp		;das Zeichen "-" eintasten
	ldi	temp,zeichen_minus	;	
	sts	digit2,temp		;das Zeichen "-" eintasten
	ldi	temp,zeichen_minus	;	
	sts	digit3,temp		;das Zeichen "-" eintasten
	ldi	temp,zeichen_minus	;	
	sts	digit4,temp		;das Zeichen "-" eintasten
	ldi	temp,zeichen_minus	;	
	sts	digit5,temp		;das Zeichen "-" eintasten
	ret				;

;*********************************************************************************************************
;***************  Scrollenden Text in den Anzeigespeicher schreiben				**********
;***************  benutzte Register:								**********
;***************  temp[1:0], Z, blinker, digit1, digit2, digit3, digit4, digit5, dp_stelle	**********
;*********************************************************************************************************
zeige_text:
	lds	temp,blinker		;
	tst	temp			;
	brne	ende_zeige_text		;
	ldi	temp,9			;
	sts	blinker,temp		;
	ldi	temp,(1<<0)		;kein Dezimalpunkt
	sts	dp_stelle,temp		;
	ldi	zh,byte2(textfeld*2)	;Zeiger auf
	ldi	zl,byte1(textfeld*2)	;Textfeld stellen
	lds	temp1,zeichen_index	;
	add	zl,temp1		;Index dazugeben
	adc	zh,null			;
	inc	temp1			;nchster Index
.if (anzeigestellen!=4)			;nur bei 4 Digits
	lpm	temp,z+			;Zeichen holen
	cpi	temp,textende		;Textende erreicht?
	brne	schreibe_digit1		;
	ldi	temp1,1			;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit1:
	sts	digit1,temp		;nein, gib Buchstaben auf das Display
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit2		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit2:
	sts	digit2,temp		;
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit3		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit3:
	sts	digit3,temp		;
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit4		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit4:
	sts	digit4,temp		;
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit5		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit5:
	sts	digit5,temp		;
.else
	lpm	temp,z+			;Zeichen holen
	cpi	temp,textende		;Textende erreicht?
	brne	schreibe_digit2		;
	ldi	temp1,1			;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit2:
	sts	digit2,temp		;nein, gib Buchstaben auf das Display
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit3		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit3:
	sts	digit3,temp		;
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit4		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit4:
	sts	digit4,temp		;
	lpm	temp,z+			;und das fr alle Anzeigestellen
	cpi	temp,textende		;
	brne	schreibe_digit5		;
	ldi	zh,byte2(textfeld*2)	;Textfeld, erstes Zeichen adressieren
	ldi	zl,byte1(textfeld*2)	;
	lpm	temp,z+			;und holen
schreibe_digit5:
	sts	digit5,temp		;
.endif
	sts	zeichen_index,temp1	;
ende_zeige_text:
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge CALC blinkend im Anzeigespeicher bereithalten			**********
;***************  benutzte Register: temp, blinker, digit1, digit2, digit3, digit4, digit5	**********
;*********************************************************************************************************
zeige_CALC_bli:
	ldi	temp,((helligkeit*250)/100)+5;lade Sollhelligkeit
	out	compare2,temp		;

	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	lds	temp,blinker		;
	tst	temp			;
	breq	calc_neu		;
	cpi	temp,15			;von 0 bis 15 Frames Anzeige aus
	brlo	calc_aus		;
	rjmp	calc_an			;
calc_neu:
	ldi	temp,35			;von 15 bis 35 Frames Anzeige an
	sts	blinker,temp		;
calc_an:
	clr	temp			;
	sts	digit1,temp		;Meldung schreiben
	ldi	temp,zeichen_C		;
	sts	digit2,temp		;
	ldi	temp,zeichen_A		;
	sts	digit3,temp		;
	ldi	temp,zeichen_L		;
	sts	digit4,temp		;
	ldi	temp,zeichen_C		;
	sts	digit5,temp		;
	ret				;
calc_aus:
	rcall	loesche_digits		;Display dunkeltasten
	ret	

;*********************************************************************************************************
;***************  Zeichenfolge CALC auf- und abschwellend im Anzeigespeicher bereithalten	**********
;***************  benutzte Register: temp, blinker, digit[1;5]					**********
;*********************************************************************************************************
zeige_CALC_dim:
	ldi	temp,(1<<0)		;
	sts	dp_stelle,temp		;kein Dezimalpunkt
	clr	temp			;
	sts	digit1,temp		;Meldung schreiben
	ldi	temp,zeichen_C		;
	sts	digit2,temp		;
	ldi	temp,zeichen_A		;
	sts	digit3,temp		;
	ldi	temp,zeichen_L		;
	sts	digit4,temp		;
	ldi	temp,zeichen_C		;
	sts	digit5,temp		;

	lds	temp,blinker		;ich benutze hier das Blinkerregister als Flag fr
	tst	temp			;Aufwrts- oder Abwrtsdimmen
	brne	calc_heller		;0  = dunkler dimmen/ungleich 0 = heller dimmen
calc_dunkler:
	clr	temp			;lsche "Flag" aufhellen
	sts	blinker,temp		;
	in	temp,compare2		;hole aktuelle Helligkeit
	subi	temp,(helligkeit/8)	;etwas dunkler bitte
	out	compare2,temp		;
	cpi	temp,10			;Minimum unterschritten?
	brlo	calc_heller		;ja, mach heller
	rjmp	ende_zeige_calc_var	;
calc_heller:
	ser	temp			;setze "Flag" aufhellen
	sts	blinker,temp		;
	in	temp,compare2		;hole aktuelle Helligkeit
	subi	temp,-(helligkeit/8)	;etwas heller bitte
	out	compare2,temp		;
	cpi	temp,((helligkeit*250)/100)+5;Maximum berschritten?
	brsh	calc_dunkler		;ja, mach dunkler
ende_zeige_calc_var:
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "n MITTELWERT" Segmentlaufzeit aktuell				**********
;***************  in Anzeigespeicher schreiben							**********
;***************  benutzte Register: t_segm,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_drehzahl:
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_drehzahl_symb	;kurz einen Kennbuchstaben zeigen

	sts	dp_stelle,temp		;
	lds	temp,t_segm_l		;hole Wert
	lds	temp1,t_segm_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ret				;
zeige_drehzahl_symb:
	rcall	loesche_digits		;Anzeige lschen
	sts	dp_stelle,temp		;auch den Dezimalpuznkt
	ldi	temp,Zeichen_n_kl	;
.if (anzeigestellen==4)			;nur bei 4 Digits
	sts	digit2,temp		;
.else					;nur bei 5 Digits
	sts	digit1,temp		;
.endif
	ret				;

;*********************************************************************************************************
;***************  Zeichenfolge "J MITTELWERT" Segmentlaufzeit alt				**********
;***************  in Anzeigespeicher schreiben							**********
;***************  benutzte Register: t_segm_delta,						**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_drehzahl_delta:
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_drehzahl_delta_symb;kurz einen Kennbuchstaben zeigen

	sts	dp_stelle,temp		;
	lds	temp,t_segm_delta_l	;hole Wert
	lds	temp1,t_segm_delta_h	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ret				;
zeige_drehzahl_delta_symb:
	rcall	loesche_digits		;Anzeige lschen
	sts	dp_stelle,temp		;auch den Dezimalpuznkt
	ldi	temp,Zeichen_J		;
.if (anzeigestellen==4)			;nur bei 4 Digits
	sts	digit2,temp		;
.else					;nur bei 5 Digits
	sts	digit1,temp		;
.endif
	ret	

;*********************************************************************************************************
;***************  Zeichenfolge "P" SEGMENTLAUFZEIT" in Anzeigespeicher schreiben		**********
;***************  benutzte Register: ablage,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_segmentlaufzeit:
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_segment_symb	;kurz einen Kennbuchstaben zeigen

	sts	dp_stelle,temp		;
	lds	temp,ablage_l		;hole Wert
	lds	temp1,ablage_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ret				;
zeige_segment_symb:
	rcall	loesche_digits		;Anzeige lschen
	sts	dp_stelle,temp		;auch den Dezimalpuznkt
	ldi	temp,zeichen_P		;
.if (anzeigestellen==4)			;nur bei 4 Digits
	sts	digit2,temp		;
.else					;nur bei 5 Digits
	sts	digit1,temp		;
.endif
	ret	

;*********************************************************************************************************
;***************  Zeichenfolge "b BANDDICKE" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: dicke_neu,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_banddicke:
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_dicke_neu_symb	;kurz einen Kennbuchstaben zeigen
.endif
	ldi	temp,(1<<3)		;
	sts	dp_stelle,temp		;Dezimalpunkt an Stelle 3
	lds	temp,dicke_neu_l	;hole letzten gerechneten Banddickewert
	lds	temp1,dicke_neu_h	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	temp,zeichen_b_kl	;	
	sts	digit1,temp		;links noch das Zeichen "b" eintasten
	ret				;
.if (anzeigestellen==4)			;nur bei 4 Digits
zeige_dicke_neu_symb:
	rcall	loesche_digits		;lsche Anzeige
	sts	dp_stelle,temp		;auch den Dezimalpuznkt;
	ldi	temp,zeichen_b_kl	;lade Kennbuchstaben und raus auf
	sts	digit2,temp		;Digit 2
	ret				;
.endif
	
;*********************************************************************************************************
;***************  Zeichenfolge "d MESSWERT" in Anzeigespeicher schreiben			**********
;***************  benutzte Register: debug,							**********
;***************     temp[1:0], digit[5:1], dp_stelle, blinker, var[2:1], tBCD[2:0], Z, null	**********
;*********************************************************************************************************
zeige_debug:
	lds	temp,blinker		;
	tst	temp			;nach dem Anzeigewechsel zunchst
	brne	zeige_debug_symb	;kurz einen Kennbuchstaben zeigen

	sts	dp_stelle,temp		;
	lds	temp,debug_l		;hole Debug-Wert
	lds	temp1,debug_h		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ret				;
zeige_debug_symb:
	rcall	loesche_digits		;Anzeige lschen
	sts	dp_stelle,temp		;auch den Dezimalpuznkt
	ldi	temp,zeichen_d_kl	;
.if (anzeigestellen==4)			;nur bei 4 Digits
	sts	digit2,temp		;
.else					;nur bei 5 Digits
	sts	digit1,temp		;
.endif
	ret				;
