;*********************************************************************************************************
;***************  konstante Daten zum Tapetimer Version 1.2 vom 2.8.2014 Stefan Kneller		**********
;*********************************************************************************************************

;*********************************************************************************************************
;***************  Tabelle fr Drehencoder							**********
;*********************************************************************************************************
dg_tab:			;Tabelle mit Drehgeber-Werten (alt-alt-neu-neu als Index) und den
			;Pegelnderungen Geber A und B low und high
			; Tabellenwerte:
			; 0 keine Bewegung
			; 1 ein Schritt vorwrts
			;-1 ein Schritt rckwrts
			; 2 Beginn Weissfeld A
			; 3 Ende   Weissfeld A 
			;aa nn			;aa nn
.db     0,2		;00 00			;00 01 A l>h
.db     -1,2		;00 10           B l>h	;00 11 A l>h und B l>h
.db     3,0		;01 00 A h>l		;01 01
.db     3,1		;01 10 A h>l und B l>h	;01 11           B l>h
.db     1,2		;10 00           B h>l	;10 01 A l>h und B h>l
.db     0,2		;10 10			;10 11 A l>h
.db     3,-1		;11 00 A h>l und B h>l	;11 01           B h>l
.db     3,0		;11 10 A h>l		;11 11

;*********************************************************************************************************
;***************  Zeichenmuster zur Darstellung auf der Siebensegmentanzeige			**********
;*********************************************************************************************************
segm_tab:

.db     Zeichen_0,Zeichen_1,Zeichen_2,Zeichen_3,Zeichen_4,Zeichen_5,Zeichen_6,Zeichen_7,Zeichen_8,Zeichen_9

;*********************************************************************************************************
;***************  Zeichenketten	fr die Anzeige	als Lauftext (max 254 Zeichen Lnge)		**********
;***************  mgliche Buchstaben: A,b,C,c,d,E,F,g,H,h,I,i,J,j,l,n,O,o,P,r,S,t,U,u		**********
;*********************************************************************************************************
string_ERROR:
.db	zeichen_E,zeichen_r_kl,zeichen_r_kl,zeichen_o_kl,zeichen_r_kl,0,0,0,0,textende

string_HALLO:
.db	zeichen_H,zeichen_A,zeichen_L,zeichen_L,zeichen_O,0,0,0
.db	zeichen_S,zeichen_t_kl,zeichen_E,zeichen_F,zeichen_A,zeichen_N,0,0,0,0,0,textende

string_Software:
.db	zeichen_S,zeichen_O,zeichen_F,zeichen_t_kl,0,0,zeichen_1_dp,zeichen_0,0,0,0,0

;*********************************************************************************************************
;***************  Daten fr das EEPROM								**********
;*********************************************************************************************************
.eseg
eeprom_konstanten:

.db	0,0xAA,byte1(def_stunden*3600/Kopfintervall),byte2(def_stunden*3600/Kopfintervall)
.db	byte3(def_stunden*3600/Kopfintervall),0,0,byte1(def_dicke/10),byte2(def_dicke/10),0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.db	0,0xAA,byte1(def_stunden*3600/Kopfintervall),byte2(def_stunden*3600/Kopfintervall)
.db	byte3(def_stunden*3600/Kopfintervall),0,0,byte1(def_dicke/10),byte2(def_dicke/10),0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.db	0,0xAA,byte1(def_stunden*3600/Kopfintervall),byte2(def_stunden*3600/Kopfintervall)
.db	byte3(def_stunden*3600/Kopfintervall),0,0,byte1(def_dicke/10),byte2(def_dicke/10),0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


