;*********************************************************************************************************
;***************  Unterprogramme zum Tapetimer Version 1.2 vom 2.8.2014 Stefan Kneller		**********
;*********************************************************************************************************

;*********************************************************************************************************
;***************  Zustand der 2 Reflexlichtschranken pollen und	in Bewegungsdaten umsetzen	**********
;***************  und die Zhlwerke fr Umdrehungen und Lagen bedienen				**********
;***************  bei Umdrehungszhlerstand 0000 den Nullstoppausgang aktivieren		**********
;***************  benutzte Register: pinb, portc, temp[2:0], Z, Feld, Lagen, Umdreh		**********
;***************                     lauf_impuls, stop_impuls					**********
;*********************************************************************************************************
hole_drehgeber:
	in	temp,pinb		;hole Eingangsstatus
	andi	temp,(1<<e_geber_b)|(1<<e_geber_a);maskiere Nutzdaten der Lichtschranken aus
	mov	temp1,flags		;hole Flags
	andi	temp1,(1<<licht_b)|(1<<licht_a);maskiere alten Zustand der Lichtschranken aus
	or	temp,temp1		;jetzt liegen alter und neuer Zustand rechtbndig in temp vor
	bst	temp,E_Geber_A		;neuer Zustand wird alter Zustand
	bld	flags,licht_a		;im Flag-Register
	bst	temp,E_Geber_B		;
	bld	flags,licht_b		;
	ldi	zl,byte1(dg_tab*2)	;Tabelle mit
	ldi	zh,byte2(dg_tab*2)	;Drehgeber-Werten
	add	zl,temp			;Index addieren
	adc	zh,null			;
	lpm	temp,z			;Wert holen
	tst	temp			;0 = keine Bewegung/-1,1 = ein Schritt/2,3 kleine Bewegung
	breq	pfeiler_ende_geberauswertung
	ldi	temp1,laufwerkpuls	;Laufwerk ist in Bewegung
	sts	lauf_impuls,temp1	;
	cpi	temp,1			;vorwrts?
	breq	vorwaerts		;
	cpi	temp,-1			;rckwrts?
	breq	rueckwaerts		;
pfeiler_ende_geberauswertung:
	rjmp	ende_geberauswertung	;
vorwaerts:
	lds	temp,feld
	inc	temp			;nchstes Feld
	sts	feld,temp		;
	cpi	temp,zebra*2		;nach einer vollen Umdrehung
	brlo	pfeiler_ende_geberauswertung
	clr	temp			;rcksetzen und
	sts	feld,temp		;
eine_Lage_mehr:
	lds	temp,lagen_l		;hole Lagenzhler
	lds	temp1,lagen_h		;
	subi	temp,byte1(-1)		;eine Bandlage mehr
	sbci	temp1,byte2(-1)		;Bandlagen haben ein physikalisches Maximum
	cpi	temp,byte1(Max_lagen+1)	;wenn das Kassettengehuse voll ist
	ldi	temp2,byte2(Max_lagen+1);
	cpc	temp1,temp2		;
	brlo	lagen_vor_gueltig	;
	ldi	temp,byte1(Max_lagen)	;Lagenzhler auf diesem Stand einfrieren
	ldi	temp1,byte2(Max_lagen)	;
lagen_vor_gueltig:
	sts	lagen_l,temp		;
	sts	lagen_h,temp1		;
eine_Umdrehung_mehr:
	lds	temp,umdreh_l		;hole Umdrehungszhler
	lds	temp1,umdreh_h		;
	subi	temp,byte1(-1)		;eine Umdrehung mehr
	sbci	temp1,byte2(-1)		;
	cpi	temp,byte1(Max_umdrehung);wenn berlauf erreicht
	ldi	temp2,byte2(Max_umdrehung)
	cpc	temp1,temp2		;
	brlo	umdrehung_vor_gueltig	;
	sbi	portb,a_stop		;Nullstopp-Ausgang aktivieren
	ldi	temp2,20		;und Nullstopp-Impuls beginnen
	sts	stop_impuls,temp2	;
	clr	temp			;Zhler rcksetzen
	clr	temp1			;
umdrehung_vor_gueltig:
	sts	umdreh_l,temp		;
	sts	umdreh_h,temp1		;
	rjmp	ende_geberauswertung	;
rueckwaerts:
	lds	temp,feld
	dec	temp			;ein Feld zurck
	sts	feld,temp		;
	cpi	temp,0xFF		;bei einer vollen Umdrehung
	brne	ende_geberauswertung	;
	ldi	temp,(zebra*2)-1	;rcksetzen und
	sts	Feld,temp		;
eine_Lage_weniger:
	lds	temp,lagen_l		;hole Lagenzhler
	lds	temp1,lagen_h		;
	cpi	temp,0			;negative Bandlagen gibt es nicht!
	cpc	temp1,null		;
	breq	eine_Umdrehung_weniger	;
	subi	temp,byte1(1)		;wenn aber noch was auf dem Wickel ist
	sbci	temp1,byte2(1)		;kann man noch eine abwickeln
	sts	lagen_l,temp		;
	sts	lagen_h,temp1		;
eine_Umdrehung_weniger:
	lds	temp,umdreh_l		;hole Umdrehungszhler
	lds	temp1,umdreh_h		;
	subi	temp,byte1(1)		;eine Umdrehung weniger
	sbci	temp1,byte2(1)		;
	cpi	temp,0			;bei Zhlerstand 0
	cpc	temp1,null		;
	brne	teste_auf_unterlauf	;
nullstopp_ausloesen:
	sbi	portb,a_stop		;Nullstopp-Ausgang aktivieren
	ldi	temp2,20		;und Nullstopp-Impuls beginnen
	sts	stop_impuls,temp2	;
	rjmp	umdrehung_rueck_gueltig	;
teste_auf_unterlauf:
	cpi	temp,byte1(Max_umdrehung);wenn Unterlauf erreicht ist
	ldi	temp2,byte2(Max_umdrehung)
	cpc	temp1,temp2		;
	brlo	umdrehung_rueck_gueltig	;
	ldi	temp,byte1(Max_umdrehung-1);Zhler rcksetzen
	ldi	temp1,byte2(Max_umdrehung-1)
umdrehung_rueck_gueltig:
	sts	umdreh_l,temp		;
	sts	umdreh_h,temp1		;
ende_geberauswertung:
	ret				;

;*********************************************************************************************************
;***************  zur BCD-Zahl im Low-Nibble temp den passenden 7-Segment-Code			**********
;***************  aus  der LookUpTable holen und in temp bereithalten				**********
;***************  benutzte Register: temp, Z, null						**********
;*********************************************************************************************************
look_up:
	ldi	zl,byte1(segm_tab*2)	;Tabelle mit Siebensegmentzeichen
	ldi	zh,byte2(segm_tab*2)	;addressieren
	andi	temp,0b00001111		;unteres Nibble maskieren
	add	zl,temp			;stelle nun den Zeiger auf das zu holende Zeichen
	adc	zh,null			;
	lpm	temp,z			;hole das Zeichen fr das Digit
	ret				;und wieder zurck

;*********************************************************************************************************
;***************  den Index der aktivierten Anzeigestelle in temp bergeben			**********
;***************  benutzte Register: temp, digit						**********
;*********************************************************************************************************
stellenselektor:			;
	clr	temp			;
	cpi	digit,(1<<5)		;ist Displaystelle 5 selektiert ?
	breq	ist_5			;
	cpi	digit,(1<<4)		;ist Displaystelle 4 selektiert ?
	breq	ist_4			;
	cpi	digit,(1<<3)		;ist Displaystelle 3 selektiert ?
	breq	ist_3			;
	cpi	digit,(1<<2)		;ist Displaystelle 2 selektiert ?
	breq	ist_2			;
	cpi	digit,(1<<1)		;ist Displaystelle 1 selektiert ?
	breq	ist_1			;
ist_5:	inc	temp			;
ist_4:	inc	temp			;
ist_3:	inc	temp			;
ist_2:	inc	temp			;
ist_1:	inc	temp			;
	ret				;

;*********************************************************************************************************
;***************  bergabe gltiger Werte temp[1:0] von oben in den Ringspeicher V		**********
;***************  benutzte Register: temp[3:0], var2[3:0], mod[2:0], Z, null			**********
;***************  ablage, t_segm_alt, t_segm							**********
;*********************************************************************************************************
in_speicher_v:
	rcall	roll_v			;Wert aus der Ablage in den Speicher bernehmen

	clr	temp
	clr	temp1
	clr	temp2			;Ergebnisregister lschen

	lds	mod0,speicher_v+0	;die letzten 4 Zeiten der Wei/Schwarz-Vorbeilufe holen
	lds	mod1,speicher_v+1	;(entspricht einer Umdrehung bei zebra == 4)
	lds	mod2,speicher_v+2	;
	lds	mod3,speicher_v+3	;
	lds	var20,speicher_v+4	;
	lds	var21,speicher_v+5	;
	lds	var22,speicher_v+6	;
	lds	var23,speicher_v+7	;

	add	temp,mod0		;alle Werte addieren
	adc	temp1,mod1		;
	adc	temp2,null		;
	add	temp,mod2		;
	adc	temp1,mod3		;
	adc	temp2,null		;
	add	temp,var20		;
	adc	temp1,var21		;
	adc	temp2,null		;
	add	temp,var22		;
	adc	temp1,var23		;
	adc	temp2,null		;
.if (zebra==8)
	lds	mod0,speicher_v+8	;4 weitere Zeiten der Wei/Schwarz-Vorbeilufe holen
	lds	mod1,speicher_v+9	;(entspricht einer Umdrehung bei zebra == 8)
	lds	mod2,speicher_v+10	;
	lds	mod3,speicher_v+11	;
	lds	var20,speicher_v+12	;
	lds	var21,speicher_v+13	;
	lds	var22,speicher_v+14	;
	lds	var23,speicher_v+15	;

	add	temp,mod0		;alle Werte addieren
	adc	temp1,mod1		;
	adc	temp2,null		;
	add	temp,mod2		;
	adc	temp1,mod3		;
	adc	temp2,null		;
	add	temp,var20		;
	adc	temp1,var21		;
	adc	temp2,null		;
	add	temp,var22		;
	adc	temp1,var23		;
	adc	temp2,null		;

	lsr	temp2			;durch 8 dividieren
	ror	temp1			;
	ror	temp			;bei zebra = 8
.endif
	lsr	temp2			;durch 4 dividieren
	ror	temp1			;
	ror	temp			;bei zebra = 4

	lsr	temp2			;
	ror	temp1			;
	ror	temp			;ergibt den Impulsdurchschnitt der letzten Umdrehung des Wickeltellers

	mov	var22,temp		;Wert fr mgliche sptere Speicherinitialisierung sichern
	mov	var23,temp1		;

	lds	var20,t_segm_l		;hole Mittelwert Umdrehungen
	lds	var21,t_segm_h		;

	sub	var20,temp		;
	sbc	var21,temp1		;ermittle den Betrag der Abweichung zum neu einglaufenen Drehzahlwert

	brcc	v_ist_positiv		;
	neg	var20			;
	com	var21			;
v_ist_positiv:
	lsl	temp			;von der letzten durchschnittlichen Segmentlaufzeit
	rol	temp1			;
	rol	temp2			;durch Multiplikation mit 8

	lsl	temp			;
	rol	temp1			;
	rol	temp2			;

	lsl	temp			;und Weglassen des letzten Bytes
	rol	temp1			;
	rol	temp2			;den 64sten Teil (1,5625%) gewinnen

	cp	var20,temp1		;wenn die Durchnittsimpulsdauer der letzten Umdrehung sich strker
	cpc	var21,temp2		;von der Durchschnittsimpulsdauer der letzten 4 Umdrehungen unterscheidet
	brlo	ende_sync_v		;habe ich zwischenzeitlich abgeschaltet/gespult/das Band gewechselt
	rcall	init_speicher_v		;stelle dann schnell eine neue Basis zur Mittelwertberechnung her
ende_sync_v:
;*********************************************************************************************************
;***************  das Auslesen der Messwerte erfolgt aus 2 Bereichen 				**********
;***************  der Mittelwert der Messwerte in den Speicherzellen				**********
;***************       "0" bis "Mittelwerttiefe*zebra*2" wird nach "T_Segm" bergeben		**********
;***************  der Mittelwert der Messwerte in den Speicherzellen				**********
;***************      "Delta*zebra*2" bis "2*zebra*(Delta+Mittelwerttiefe)" wird nach		**********
;***************      "T_Segm_alt" bergeben							**********
;*********************************************************************************************************
mittelwert_v:
	clr	mod0			;Ergebnisregister lschen
	clr	mod1			;
	clr	mod2			;
	ldi	zh,byte2(speicher_v)	;
	ldi	zl,byte1(speicher_v)	;Zeiger auf erste Zelle Speicherbereich "neu"  stellen
summiere_v:
	ld	temp,z+			;16-Bit Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;2. Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;3 Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;4. Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	cpi	zl,byte1(speicher_v+(mittelwerttiefe*zebra*2))
	ldi	temp2,byte2(speicher_v+(mittelwerttiefe*zebra*2))
	cpc	zh,temp2		;alle Werte im Speicherbereich "Mittelwert V neu" schon aufsummiert?
	brlo	summiere_v		;
	ldi	temp,Mittelwerttiefe+zebra/2	;ja, dann hier schon runden

	add	mod0,temp		;
	adc	mod1,null		;
	adc	mod2,null		;

	lsl	mod0			;und durch 128 teilen
	rol	mod1			;(indem ich mit 2 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=16)
	lsl	mod0			;und durch 64 teilen
	rol	mod1			;(indem ich mit 4 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=8)
	lsl	mod0			;und durch 32 teilen
	rol	mod1			;(indem ich mit 8 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=4)
	lsl	mod0			;und durch 16 teilen
	rol	mod1			;(indem ich mit 16 multipliziere
	rol	mod2			;
.endif
.endif
.endif
	sts	T_Segm_l,mod1		;und das niederwertigste Byte entfallen lasse
	sts	T_Segm_h,mod2		;gewonnenen Mittelwert weglegen



	rcall	rechne_radius		;zeig mir den dazugehrenden Wickelradius

mittelwert_v_delta:
	clr	mod0			;Register vorbereiten
	clr	mod1			;
	clr	mod2			;

	ldi	zh,byte2(speicher_v+(delta_v*zebra*2))
	ldi	zl,byte1(speicher_v+(delta_v*zebra*2));Zeiger auf erste Zelle Speicherbereich "Mittelwert V Delta"  stellen

summiere_v_delta:
	ld	temp,z+			;16-Bit Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;2. Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;3 Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	ld	temp,z+			;4. Zahl laden
	ld	temp1,z+		;
	add	mod0,temp		;Wert aufsummieren
	adc	mod1,temp1		;
	adc	mod2,null		;

	cpi	zl,byte1(speicher_v+(2*zebra*(delta_v+mittelwerttiefe)))
	ldi	temp2,byte2(speicher_v+(2*zebra*(delta_v+mittelwerttiefe)))

	cpc	zh,temp2		;Speicherbereich "V Delta" abgearbeitet?
	brlo	summiere_v_delta	;
	ldi	temp,Mittelwerttiefe*zebra/2	;ja, dann hier schon runden

	add	mod0,temp		;
	adc	mod1,null		;
	adc	mod2,null		;

	lsl	mod0			;und durch 128 teilen
	rol	mod1			;(indem ich mit 2 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=16)
	lsl	mod0			;und durch 64 teilen
	rol	mod1			;(indem ich mit 4 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=8)
	lsl	mod0			;und durch 32 teilen
	rol	mod1			;(indem ich mit 8 multipliziere
	rol	mod2			;
.if (mittelwerttiefe!=4)
	lsl	mod0			;und durch 16 teilen
	rol	mod1			;(indem ich mit 16 multipliziere
	rol	mod2			;
.endif
.endif
.endif
	sts	T_Segm_delta_l,mod1	;und das niederwertigste Byte entfallen lasse
	sts	T_Segm_delta_h,mod2	;gewonnenen Mittelwert weglegen
	rcall	rechne_dicke		;aus beiden Mittelwerten den Dickenwert des Bandes errechnen
ende_speicher_v:
	ret				;

;*********************************************************************************************************
;***************  Wert in der "Ablage" in den Speicher V bernehmen und				**********
;***************  alle Messwerte im Speicher V um einen Wert (ein Speicherzellenpaar)		**********
;***************  nach unten schieben; der lteste Wert fllt heraus				**********
;***************  benutzte Register: Z, temp[3:0], var2[3:0]					**********
;*********************************************************************************************************
roll_v:
	ldi	zh,byte2(speicher_v+(2*Zebra*(Mittelwerttiefe+Delta_v))+8)
	ldi	zl,byte1(speicher_v+(2*Zebra*(Mittelwerttiefe+Delta_v))+8)

roll_v_weiter:
	subi	zl,byte1(18)		;Zeiger passend drehen
	sbci	zh,byte2(18)		;

	ld	temp,z+			;hole 4 Stck 16-Bit Werte auf einmal
	ld	temp1,z+		;
	ld	temp2,z+		;
	ld	temp3,z+		;
	ld	var20,z+		;
	ld	var21,z+		;
	ld	var22,z+		;
	ld	var23,z+		;

	subi	zl,byte1(6)		;Zeiger passend drehen
	sbci	zh,byte2(6)		;

	st	z+,temp			;und alles ein Zellenpaar
	st	z+,temp1		;tiefer sichern
	st	z+,temp2		;
	st	z+,temp3		;
	st	z+,var20		;
	st	z+,var21		;
	st	z+,var22		;
	st	z+,var23		;

	cpi	zl,byte1(speicher_v+8)	;
	ldi	temp,byte2(speicher_v+8);
	cpc	zh,temp			;schon alle Werte durchgerollt?
	brne	roll_v_weiter		;
	ret				;

;*********************************************************************************************************
;***************  Banddickenwert ermitteln und gltige Werte im Ringspeicher U ablegen		**********
;***************  Formel:									**********
;***************  d = (T_segm-T_segm_vor_delta_Umdreh.)*Vo*Zebra*Teiler1/2*Pi*Clk*delta_Umdreh.	**********
;***************  normiert zu:	Dickenzahl = (((T_segm - T_segm_alt)*24772)+512)/1024		**********
;***************  benutzte Register: temp[3:0], T_segm, T_segm_delta, dicke			**********
;***************                     var1[2:0], var2[2:0], mod[2:0], flags2 			**********
;*********************************************************************************************************
rechne_dicke:
	lds	temp,t_segm_l		;letzten Geschwindigkeitsmittelwert laden
	lds	temp1,t_segm_h		;

	lds	temp2,t_segm_delta_l	;Geschwindigkeitsmittelwert delta_U Umdrehungen vorher laden
	lds	temp3,t_segm_delta_h	;

	sub	temp,temp2		;neu minus alt
	sbc	temp1,temp3		;(T_segm - T_segm_vor_delta_Umdrehungen)

	cpi	temp,byte1(max_dicke*delta_v*392699/(bandgeschw*1000*zebra))
	ldi	temp2,byte2(max_dicke*delta_v*392699/(bandgeschw*1000*zebra));K = 2*Pi*Clk/Teiler1
	cpc	temp1,temp2		;nicht erlaubte Werte aussortieren
	brsh	u_ungueltig		;78

	cpi	temp,byte1(min_dicke*delta_v*392699/(bandgeschw*1000*zebra))
	ldi	temp2,byte2(min_dicke*delta_v*392699/(bandgeschw*1000*zebra));K = 2*Pi*Clk/Teiler1
	cpc	temp1,temp2		;
	brlo	u_ungueltig		;33

	sbr	flags2,(1<<t_segm_val)	;bei ausreichender Annherung beider Mittelwerte V
					;ist eine gltige Banddicke vorauszusetzen, "valide" melden

	ldi	var20,byte1(bandgeschw*10000*zebra/(delta_v*38349));
	ldi	var21,byte2(bandgeschw*10000*zebra/(delta_v*38349));K = 200*Pi*Clk/(Teiler1*1024)

	rcall	mul16u			;multiplizieren ((T_segm - T_segm_alt)*6193

;***************  ab hier bentige ich wegen des eingeschrnkten Wertebereiches nicht mehr alle Bytes  ***

	mov	var11,mod1		;Ergebnis umladen
	mov	var12,mod2		;
	mov	var13,mod3		;

	subi	var11,byte2(-512)	;Rundung vornehmen
	sbci	var12,byte3(-512)	;
	sbci	var13,byte4(-512)	;

	lsr	var13			;dividieren durch 1024 indem ich um
	ror	var12			;2 Stellen nach rechts schiebe und
	ror	var11			;

	lsr	var13			;
	ror	var12			;
	ror	var11			;

	mov	temp,var11		;das niederwertigste Byte ignoriere
	mov	temp1,var12		;

	subi	temp,byte1(-dickenoffset);mit einem Offset knnten hier Fehler reduziert werden
	sbci	temp1,byte2(-dickenoffset)

sts	debug_l,temp
sts	debug_h,temp1

	rjmp	in_filter_u		;Banddickenwert in den Filter bergeben
u_ungueltig:
	cbr	flags2,(1<<t_segm_val)	;
	rjmp	ende_filter_u		;
;*********************************************************************************************************
;***************  bernahme eines validen Wertes temp[1:0] in die Mittelwertbildung U		**********
;*********************************************************************************************************
in_filter_u:
;rjmp	filtere_u_1		;feste Filtertiefe 32 fr Kennlinienaufnahme
	sbrc	flags2,synchron		;nach der Synchronisiation
	rjmp	filtere_u_3		;Mittelwert Dicke stark beruhigen
	lds	temp2,mess_impuls	;Messdauerzhler fr Banddickenvalidierung holen
	cpi	temp2,filterwechsel_u	;nach kurzer Einschwingphase mit Filtertiefe 32
	brsh	filtere_u_2		;auf zweite Filtertiefe 128 umschalten
;*********************************************************************************************************
;***************  erste Filtertiefe U 32							**********
;***************  Wertebereich Speichertiefe: 16, 32, 64, 128					**********
;*********************************************************************************************************
filtere_u_1:
	lds	var20,dicke_f		;hole
	lds	var21,dicke_l		;
	lds	var22,dicke_h		;Banddicke[H:L:F]

	subi	var20,byte1(-filtertiefe_u1/2)	;hier runden
	sbci	var21,byte2(-filtertiefe_u1/2)
	sbci	var22,byte3(-filtertiefe_u1/2)

	mov	mod0,var20		;kopieren
	mov	mod1,var21		;
	mov	mod2,var22		;und multipliziere mit:
	mov	mod3,null		;

	lsl	mod0			;*2
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u1!=128)
	lsl	mod0			;*4
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u1!=64)
	lsl	mod0			;*8
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u1!=32)
	lsl	mod0			;*16
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.endif
.endif
.endif
	subi	var20,byte1(filtertiefe_u1/2)	;Dickenwert vor Rundung wiederherstellen
	sbci	var21,byte2(filtertiefe_u1/2)
	sbci	var22,byte3(filtertiefe_u1/2)

	sub	var20,mod1		;/256
	sbc	var21,mod2		;
	sbc	var22,mod3		;und ziehe das gewonnene 128/64/32/16tel des Mittelwertes vom Alten ab

	clr	temp2			;Register vorbereiten

	subi	temp,byte1(-filtertiefe_u1/2)	;hier runden
	sbci	temp1,byte2(-filtertiefe_u1/2)
	sbci	temp2,byte3(-filtertiefe_u1/2)

	lsl	temp			;den neuen Eingangswert multiplizieren mit:
	rol	temp1			;
	rol	temp2			;*2
.if (filtertiefe_u1!=128)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*4
.if (filtertiefe_u1!=64)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*8
.if (filtertiefe_u1!=32)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*16
.endif
.endif
.endif
	add	var20,temp		;/256
	adc	var21,temp1		;
	adc	var22,temp2		;addiere das gewonnene 128/64/32/16tel des neuen Eingangswertes zum Mittelwert

	rjmp	sichere_dicke

;*********************************************************************************************************
;***************  zweite Filtertiefe U 128							**********
;***************  Wertebereich Speichertiefe: 16, 32, 64, 128					**********
;*********************************************************************************************************
filtere_u_2:
	lds	var20,dicke_f		;hole
	lds	var21,dicke_l		;
	lds	var22,dicke_h		;Banddicke[H:L:F]

	subi	var20,byte1(-filtertiefe_u2/2)	;hier runden
	sbci	var21,byte2(-filtertiefe_u2/2)
	sbci	var22,byte3(-filtertiefe_u2/2)

	mov	mod0,var20		;kopieren
	mov	mod1,var21		;
	mov	mod2,var22		;und multipliziere mit:
	mov	mod3,null		;

	lsl	mod0			;*2
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u2!=128)
	lsl	mod0			;*4
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u2!=64)
	lsl	mod0			;*8
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.if (filtertiefe_u2!=32)
	lsl	mod0			;*16
	rol	mod1			;
	rol	mod2			;
	rol	mod3			;
.endif
.endif
.endif
	subi	var20,byte1(filtertiefe_u2/2)	;Dickenwert vor Rundung wiederherstellen
	sbci	var21,byte2(filtertiefe_u2/2)
	sbci	var22,byte3(filtertiefe_u2/2)

	sub	var20,mod1		;/256
	sbc	var21,mod2		;
	sbc	var22,mod3		;und ziehe das gewonnene 128/64/32/16tel des Mittelwertes vom Alten ab

	clr	temp2			;Register vorbereiten

	subi	temp,byte1(-filtertiefe_u2/2)	;hier runden
	sbci	temp1,byte2(-filtertiefe_u2/2)
	sbci	temp2,byte3(-filtertiefe_u2/2)

	lsl	temp			;den neuen Eingangswert multiplizieren mit:
	rol	temp1			;
	rol	temp2			;*2
.if (filtertiefe_u2!=128)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*4
.if (filtertiefe_u2!=64)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*8
.if (filtertiefe_u2!=32)
	lsl	temp			;
	rol	temp1			;
	rol	temp2			;*16
.endif
.endif
.endif
	add	var20,temp		;/256
	adc	var21,temp1		;
	adc	var22,temp2		;addiere das gewonnene 128/64/32/16tel des neuen Eingangswertes zum Mittelwert

	rjmp	sichere_dicke		;

;*********************************************************************************************************
;***************  dritte Filtertiefe U 512							**********
;***************  Wertebereich Speichertiefe: 256, 512						**********
;*********************************************************************************************************
filtere_u_3:
	lds	var20,dicke_f		;hole eingeschwungenen Dickenwert
	lds	var21,dicke_l		;
	lds	var22,dicke_h		;dicke[H:L:F] = [high:low:fraction]
.if (filtertiefe_u3==256)
;*********************************************************************************************************
;***************  Speichertiefe U 256 Werte							**********
;*********************************************************************************************************
	subi	var20,byte1(-128)	;hier runden
	sbci	var21,byte2(-128)	;
	sbci	var22,byte3(-128)	;

	mov	mod0,var21		;nehme ein 256stel davon
	mov	mod1,var22		;

	subi	var20,byte1(128)	;eingeschwungenen Dickenwert vor Rundung wiederherstellen
	sbci	var21,byte2(128)	;
	sbci	var22,byte3(128)	;

	sub	var20,mod0		;und ziehe das vom alten Mittelwert ab
	sbc	var21,mod1		;
	sbc	var22,null		;bertrag bercksichtigen
.else
;*********************************************************************************************************
;***************  Speichertiefe U 512 Werte							**********
;*********************************************************************************************************
	subi	var20,byte1(-256)	;hier runden
	sbci	var21,byte2(-256)	;
	sbci	var22,byte3(-256)	;

	mov	mod0,var21		;nehme ein 256stel davon
	mov	mod1,var22		;

	lsr	mod1			;und halbiere weiter auf dann 1/512
	ror	mod0			;

	subi	var20,byte1(256)	;Dickenwert vor Rundung wiederherstellen
	sbci	var21,byte2(256)	;
	sbci	var22,byte3(256)	;

	sub	var20,mod0		;ziehe 1/512tel vom alten Mittelwert ab
	sbc	var21,mod1		;
	sbc	var22,null		;bertrag bercksichtigen

	subi	temp,byte1(-1)		;hier wieder runden
	sbci	temp1,byte2(-1)		;

	lsr	temp1			;nimm die Hlfte vom Eingangswert
	ror	temp			;und davon
.endif
	add	var20,temp		;1/256stel (dann insgesamt 1/512stel) des Eingangswertes
	adc	var21,temp1		;auf den Mittelwert draufaddieren
	adc	var22,null		;bertrag bercksichtigen
sichere_dicke:
	sts	dicke_f,var20		;neuen Mittelwert sichern
	sts	dicke_l,var21		;
	sts	dicke_h,var22		;
ende_filter_u3:
ende_filter_u:
	ret				;fertig

;*********************************************************************************************************
;***************  Dickenwert validieren								**********
;***************  wird jede Sekunde von Hauptschleife aufgerufen				**********
;***************  Abhngig vom Zeitfenster wird die Validierung oder Synchronisation erlaubt	**********
;***************  oder erzwungen.								**********
;***************  Versuche mit variablem Fenster waren mit billiger Kassetten erfolglos.	**********
;*********************************************************************************************************
validiere_u:
	lds	temp,mess_impuls	;
	inc	temp			;Messdauerzhler fr Banddickenvalidierung bedienen
	sts	mess_impuls,temp	;
	cpi	temp,sync_sperre	;Fenster fr Validierung offen
	brlo	ende_val_u		;nein
	cpi	temp,sync_pflicht	;Zeitpunkt fr Zwangssynchronisierung erreicht?
	brsh	u_ist_valide		;ja
	sbrs	flags2,t_segm_val	;nur bei neu einlaufenden gltigen Dickenwerten
	rjmp	ende_val_u		;
	andi	temp,0b00000111		;maskiere 8 Sekundenraster aus
	tst	temp			;und alle 8 Sekunden
	brne	ende_val_u		;
	lds	temp,dicke_l		;hole den Dickenwert
	lds	temp1,dicke_h		;
	lds	temp2,dicke_alt_l	;hole vorherigen Dickenwert
	lds	temp3,dicke_alt_h	;
	sts	dicke_alt_l,temp	;neue Dicke
	sts	dicke_alt_h,temp1	;wird zur alten

	sub	temp2,temp		;wie ist der betragsmige Unterschied 
	sbc	temp3,temp1		;der beiden Werte, die 8 Sekunden auseinanderliegen
	brcc	u_ist_positiv		;
	neg	temp2			;
	com	temp3			;
u_ist_positiv:
	cpi	temp2,low(8*delta_u/100);wenn aktuelle Banddicke sich von der vorherigen zu stark unterscheidet
	ldi	var20,high(8*delta_u/100);habe ich zwischenzeitlich abgeschaltet/gespult/das Band gewechselt
	cpc	temp3,var20		;
	brsh	ende_val_u		;und muss noch etwas warten, sonst
u_ist_valide:
	sbr	flags2,(1<<dicke_val)	;gib grnes Licht zur Zeitrechnung
ende_val_u:
	ret

;*********************************************************************************************************
;***************  Errechne die aufgespulten Lagen						**********
;***************  Grundformel: counts = r * 2 * Pi * CLK/(Vo * Weifelderzahl * Vorteiler1)	**********
;***************  entspricht: R_aktuell = T_segm * V_o * Zebra * Vorteiler_1/(Pi * 2 * CLK)	**********
;***************  Weiter gilt: Lagen = (Radius_aktuell - Kernradius)/Banddicke			**********
;***************  Beide Gleichung zusammengefhrt und fr den Controller umgeformt zu:		**********
;***************  Lagen = (T_segm*24772+128)/256-(100*Kernradius-Dickenwert/2))/Dickenwert	**********
;***************  bentigte Register: fast alle :-)						**********
;*********************************************************************************************************
lagen_absolut:
;rechne Term A: ((T_Segm*12386)+128)/256 = scratch[2:0]

	lds	var10,T_Segm_l		;lade Tellerdrehzahl
	lds	var11,T_Segm_h		;

	ldi	var20,byte1((zebra*bandgeschw*100+767)/1534)
	ldi	var21,byte2((zebra*bandgeschw*100+767)/1534);K = 2*Pi*CLK/(Teiler1*256)

	rcall	mul16u			;rechne: "T_segm * 24772"

	mov	var10,mod0		;Zwischenergebnis umladen
	mov	var11,mod1		;
	mov	var12,mod2		;
	mov	var13,mod3		;

	subi	var10,byte1(-128)	;rechne: "+ 128"
	sbci	var11,byte2(-128)	;
	sbci	var12,byte3(-128)	;zwecks Rundung
	sbci	var13,byte4(-128)	;

	sts	scratch_0,var11		;rechne: "/ 256"
	sts	scratch_1,var12		;das niederwertigste Byte entfallen lassen und das
	sts	scratch_2,var13		;Zwischenergebnis nach scratch[2:0] weglegen

;rechne Term B: 100*Kernradius-Dickenwert/2 = var2[3:0]

	lds	var20,Kernradius_0	;hole Kernradius * 100
	lds	var21,Kernradius_1	;
	lds	var22,Kernradius_2	;
	ldi	var23,0			;

	lds	var10,dicke_l		;hole Dickenwert
	lds	var11,dicke_h		;

	lsr	var11			;rechne: "Dickenwert / 2"
	ror	var10			;

	sub	var20,var10		;rechne: "(100 * Kernradius) - Dickenwert/2"
	sbc	var21,var11		;
	sbc	var22,null		;

	lds	var10,scratch_0		;hole Zwischenergebnis A
	lds	var11,scratch_1		;
	lds	var12,scratch_2		;
	ldi	var13,0			;

	cp	var10,var20		;A < B ? dann ist der gemessene Wickelradius kleiner
	cpc	var11,var21		;als der Bobbyradius und es wrde eine negative
	cpc	var12,var22		;Lagenzahl errechnet werden, was nicht erlaubt ist
;	cpc	var13,var23		;
	brsh	rechne_A_minus_B	;
	rjmp	ende_lagen_absolut	;warte dann ab oder
;	rcall	rechne_radius		;errechne aus T-Segm einen neuen Bobbyradius*100
;	sts	kernradius_0,var20	;bergib ihn nach Kernradius und
;	sts	kernradius_1,var21	;
;	sts	kernradius_2,var22	;
;	rjmp	lagen_absolut		;durchlaufe dieses Unterprogramm damit erneut

rechne_A_minus_B:
;rechne A - B = C
;scratch[2:0] - var2[2:0] = var1[2:0]

	sub	var10,var20		;rechne: "A - B"
	sbc	var11,var21		;
	sbc	var12,var22		;
;	sbc	var13,var23		;

;rechne C / dicke
;var1[3:0] / dicke
;vor der Division Rundung vornehmen

	lds	mod0,dicke_l		;hole Dickenwert
	lds	mod1,dicke_h		;

	lsr	mod1			;halbieren
	ror	mod0			;

	add	var10,mod0		;und zwecks Rundung zum Dividend addieren
	adc	var11,mod1		;
	adc	var12,null		;bertrag bercksichtigen
	adc	var13,null		;auch frs MSB

	lds	var20,dicke_l		;hole Dickenwert
	lds	var21,dicke_h		;
	ldi	var22,0			;
	ldi	var23,0			;

	rcall	div32u			;rechne: "C / Dickenwert"

;***************  die errechneten Lagen sind mit einem Offset behaftet, da der zugrundeliegende
;***************  Radius_aktuell durch die Mittelwertbildung immer eine Verzgerung von
;***************  Mittelwerttiefe/2 aufweist. Die Korrektur folgt jetzt:

	subi	var10,byte1(-Mittelwerttiefe/2)
	sbci	var11,byte2(-Mittelwerttiefe/2)

	sts	lagen_l,var10		;gerechnete Lagenzahl sichern
	sts	lagen_h,var11		;
ende_lagen_absolut:
	ret

;*********************************************************************************************************
;***************  Berechnung einer Lagenzahl, die zur im Display angezeigten Zeit passt um zu	**********
;***************  verhindern, dass die Zeitanzeige beim Beginn des Spulbetriebs springt		**********
;***************  Grundformel: T = (2 * PI * Lagen * (R_o + (Lagen + 1) * (Banddicke/2))) / V_o	**********
;***************  aufgelst nach Lagen								**********
;***************  L = (Wurzel((Banddicke/2+Ro)^2+T*Banddicke*Vo/Pi)-Banddicke/2-Ro)/Banddicke	**********
;***************  Gleichung fr den Controller umgeformt und normiert zu:			**********
;***************  Lagen = (64*Wurzel(((Dickenwert/2+100*Kernradius)/64)^2+Dickenwert*T*369)-	**********
;***************  Fortsetzung von oben: (Dickenwert/2+100*Kernradius))/Dickenwert		**********
;***************  bentigte Register: var1[3:0], var2[3:0], lc, lagen, dicke, Zeit_anz		**********
;***************                      scratch[3:0], memory[2:0], mod[4:0], null			**********
;*********************************************************************************************************
setze_lagenzahl:

;rechne Term A: dicke/2+100*Kernradius = memory[2:0]

	lds	var10,dicke_l		;hole Dickenwert
	lds	var11,dicke_h		;

	lsr	var11			;rechne: "Dickenwert / 2"
	ror	var10			;

	lds	var20,Kernradius_0	;lade 100*Kernradius
	lds	var21,Kernradius_1	;
	lds	var22,Kernradius_2	;

	add	var20,var10		;rechne: "Dickenwert / 2 + 100 * Kernradius"
	adc	var21,var11		;
	adc	var22,null		;bertrag bercksichtigen

	sts	memory_0,var20		;Zwischenergebnis nach "Memory" weglegen
	sts	memory_1,var21		;
	sts	memory_2,var22		;

;rechne Term B: (Term A/64)^2 = scratch[3:0]

	lsl	var20			;rechne: "(Dickenwert / 2 + 100 * Kernradius) / 64"
	rol	var21			;
	rol	var22			;indem mit 4 multipliziert wird

	lsl	var20			;und das niederwertigste Byte "var20 "entfllt
	rol	var21			;
	rol	var22			;

	mov	var10,var21		;Operanden fr Quadrierung laden
	mov	var11,var22		;
	mov	var20,var21		;
	mov	var21,var22		;

	rcall	mul16u			;rechne: "((Dicke / 2 + 100 * Kernradius) / 64)^2"

	sts	scratch_0,mod0		;Zwischenergebnis nach "Scratch" weglegen
	sts	scratch_1,mod1		;
	sts	scratch_2,mod2		;
	sts	scratch_3,mod3		;

;rechne Term C: dicke*T*369 = mod[3:0]

	lds	var10,dicke_l		;hole Dickenwert
	lds	var11,dicke_h		;

	ldi	var20,byte1(bandgeschw*100/12868)	;lade Multiplikator
	ldi	var21,byte2(bandgeschw*100/12868)	;K = (16*Pi*256)

	rcall	mul16u			;rechne: "Dickenwert * 369" = mod[3:0]

	mov	var20,mod0		;Ergebnis, 20Bit breit, fr Weiterverarbeitung umladen
	mov	var21,mod1		;
	mov	var22,mod2		;

	lds	var10,zeit_anz_l	;hole Quarzzeit im Display, 12Bit
	lds	var11,zeit_anz_h	;

	rcall	mul16x24u		;rechne: "Dickenwert * T * 369" = mod[3:0]

;rechne Term D: Wurzel(Term B+Term C) = mod[3:0]

	lds	var10,scratch_0		;hole "((Dickenwert / 2 + 100 * Kernradius) / 64)^2"
	lds	var11,scratch_1		;
	lds	var12,scratch_2		;
	lds	var13,scratch_3		;

	add	mod0,var10		;rechne: "((Dickenwert / 2 + 100 * Kernradius) / 64)^2
	adc	mod1,var11		;         + Dickenwert * T * 369"
	adc	mod2,var12		;
	adc	mod3,var13		;

	rcall	Sqrt32			;davon die Quadratwurzel ziehen = var1[1:0]

;***************  Durch Umstellung der Grundformel und Einengung des Wertebereiches auf Integer 
;***************  ist im vorhergehenden nicht gewhrleistet, dass fr den Eingangswert T = 0 Sekunden
;***************  die resultierende Restformel: 64 * Wurzel((x / 64)^2) = x aufgeht.
;***************  Daher wird nachfolgende Korrektur vorgenommen

	subi	var10,byte1(-1)		;
	sbci	var11,byte2(-1)		;

;rechne Term E: D*64 = var1[2:0]

	mov	var12,var11		;Ergebnis mit 64 multiplizieren indem ich
	mov	var11,var10		;
	clr	var10			;mit 256 multipliziere und

	lsr	var12			;durch 4 dividiere
	ror	var11			;
	ror	var10			;

	lsr	var12			;
	ror	var11			;
	ror	var10			;

;rechne Term F: (Term E-Term A)/dicke = var1[1:0]

	lds	var20,memory_0		;hole "Dickenwert / 2 + 100 * Kernradius"
	lds	var21,memory_1		;
	lds	var22,memory_2		;

	sub	var10,var20		;rechne:
	sbc	var11,var21		;"64*Wurzel(((Dickenwert/2+100*Kernradius)/64)^2+Dickenwert*T*369)
	sbc	var12,var22		;   -(Dickenwert/2+100*Kernradius)"
	clr	var13			;

;hier vor der Division Rundung vornehmen

	lds	mod0,dicke_l		;hole Dickenwert
	lds	mod1,dicke_h		;

	lsr	mod1			;halbieren
	ror	mod0			;

	add	var10,mod0		;und zwecks Rundung zum Dividend addieren
	adc	var11,mod1		;
	adc	var12,null		;bertrag bercksichtigen
	adc	var13,null		;auch frs MSB

	lds	var20,dicke_l		;hole Divisor "Dickenwert"
	lds	var21,dicke_h		;
	ldi	var22,0			;
	ldi	var23,0			;

	rcall	div32u			;dividiere dann alles

	sts	lagen_l,var10		;sichere Ergebnis
	sts	lagen_h,var11		;
	ret				;

;*********************************************************************************************************
;***************  Errechne die Abgespielte Zeit t_calc in Sekunden nach der Formel:		**********
;***************	T = (2 * PI * Lagen * (R_o + (Lagen + 1) * (Banddicke/2))) / V_o	**********
;***************  Gleichung fr den Controller umgeformt und normiert zu:			**********
;***************  T = (((Lagen*(100*Kernradius+((Lagen+1)*Dickenwert/2))))/256+1477)/2953	**********
;*********************************************************************************************************
sekunden_absolut:
	lds	var10,lagen_l		;hole Lagenanzahl
	lds	var11,lagen_h		;

	subi	var10,byte1(-1)		;rechne: "Lagen + 1"
	sbci	var11,byte2(-1)		;

	lds	var20,dicke_l		;lade Dickenwert
	lds	var21,dicke_h		;

	rcall	mul16u			;rechne: "(Lagen + 1) * Dickenwert"

	lsr	mod3			;rechne: "(Lagen + 1) * Dickenwert / 2"
	ror	mod2			;
	ror	mod1			;
	ror	mod0			;

	lds	var20,Kernradius_0	;lade 100*Kernradius
	lds	var21,Kernradius_1	;
	lds	var22,Kernradius_2	;

	add	var20,mod0		;rechne: "(Lagen + 1) * Dickenwert / 2 + 100 * Kernradius"
	adc	var21,mod1		;
	adc	var22,mod2		;

	lds	var10,lagen_l		;hole Lagenanzahl
	lds	var11,lagen_h		;

	rcall	mul16x24u		;rechne: "Lagen * ((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius)"
	
	ldi	var10,byte1(bandgeschw*1000/32170)	;Rundungsoperanden laden
	ldi	var11,byte2(bandgeschw*1000/32170)	;
	ldi	var12,byte3(bandgeschw*1000/32170)	;
	ldi	var13,byte4(bandgeschw*1000/32170)	;K = 40*PI*256

	add	var10,mod1		;rechne: "Lagen * (((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius))
	adc	var11,mod2		;         / 256 + 1477"
	adc	var12,mod3		;
	adc	var13,mod4		;

	ldi	var20,byte1(bandgeschw*1000/16085)	;Divisor laden
	ldi	var21,byte2(bandgeschw*1000/16085)	;
	ldi	var22,byte3(bandgeschw*1000/16085)	;
	ldi	var23,byte4(bandgeschw*1000/16085)	;K = 20*PI*256

	rcall	div32u			;rechne: "(Lagen * (((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius))
					;         / 256 + 1477)/2953"
	sts	zeit_calc_l,var10	;Sekunden sichern
	sts	zeit_calc_h,var11	;
	ret				;

;*********************************************************************************************************
;***************  aus der Segmentlaufzeit den Wickelradius berechnen und weglegen		**********
;***************  den 100.000-fachen Wickelradius fr weitergehende Rechnung bereithalten	**********
;***************  Formel: r = counts * Vo * Zebra * Teiler1/(2 * Pi * CLK)			**********
;***************  fr den Controller umgeformt und normiert zu:					**********
;***************  Radiuszahl = T_Segm*((Zebra*Bandgeschw*100/1534)/256)*16777/2^24		**********
;***************  benutzte Register: var1[1:0], var2[2:0], mod[4:0], Radius, T-Segm		**********
;*********************************************************************************************************
rechne_radius:
	lds	var10,t_segm_l		;hole Geschwindigkeitsmittelwert
	lds	var11,t_segm_h		;

	ldi	var20,byte1((zebra*bandgeschw*100+767)/1534);K = 2*Pi*CLK/(Teiler1*256)
	ldi	var21,byte2((zebra*bandgeschw*100+767)/1534);ermittle Wickelradius * 256*100.000

	rcall	mul16u			; "T-Segm * Zebra * 3097/256" = mod[3:0]

	mov	var20,mod1		;und sichere den 256sten Teil (=100*Wickelradius)
	mov	var21,mod2		;
	mov	var22,mod3		;
	mov	var23,mod0		;die "Nachkommastellen" fr die Rundung behalten

	subi	var23,byte1(-128)	;addiere 128 zwecks Rundung
	sbci	var20,byte2(-128)	;
	sbci	var21,byte3(-128)	;
	sbci	var22,byte4(-128)	;

	ldi	var10,byte1(16777)	;lade Multiplikator
	ldi	var11,byte2(16777)	;K = 2^24/1000

	rcall	mul16x24u		;

	sts	radius_l,mod3		;sichere den 2^24sten Teil
	sts	radius_h,mod4		;
					;da der Radius nicht aus der aktuellen Tellerdrehzahl
					;sonder aus der Durchschnittlichen ermittelt wurde
					;existiert ein Offset von -Banddicke*Mittelwerttiefe/2
					;den ich aber nicht korrigiere
	ret				;

;*********************************************************************************************************
;***************  aus Lagenzahl und Banddicke den Wickelradius berechnen			**********
;***************  Formel: r = Kernradius + lagen * banddicke		 			**********
;***************  fr den Controller umgeformt und normiert zu:					**********
;***************  Radiuszahl = (Kernradius * 100 + lagen * dickenzahl)*16777/(2^16)		**********
;***************  benutzte Register: var1[3:0], var2[2:0], mod[3:0], kernradius, dicke, lagen	**********
;*********************************************************************************************************
zaehle_radius:
	lds	var10,dicke_l		;lade Banddicke
	lds	var11,dicke_h		;

	lds	var20,lagen_l		;lade Lagenzahl
	lds	var21,lagen_h		;

	rcall	mul16u			;rechne: "Lagen * Dickenzahl"

	lds	var10,Kernradius_0	;lade Kernradius * 100
	lds	var11,Kernradius_1	;
	lds	var12,Kernradius_2	;
	ldi	var13,0			;Register lschen

	add	var10,mod0		;rechne: "Kernradius * 100 + lagen * dicke"
	adc	var11,mod1		;
	adc	var12,mod2		;
	adc	var13,mod3		;bertrag bercksichtigen

	subi	var10,byte1(-500)	;mit 500 runden, da ich durch 1000 dividieren werde
	sbci	var11,byte2(-500)	;
	sbci	var12,byte3(-500)	;
	sbci	var13,byte4(-500)	;

	mov	var20,var11		;und den 256sten Teil sichern
	mov	var21,var12		;
	mov	var22,var13		;

	ldi	var10,byte1(16777)	;lade Multiplikator
	ldi	var11,byte2(16777)	;K = 2^24/1000

	rcall	mul16x24u		;

	sts	radius_l,mod2		;sichere den 2^16sten Teil
	sts	radius_h,mod3		;
	ret				;

;*********************************************************************************************************
;***************  Die errechnete abgespielte Zeit wird an die Anzeige bergeben			**********
;***************  benutzte Register:temp, temp1, zeit_calc, zeit_anz				**********
;*********************************************************************************************************
uebergebe_zeit:
	lds	temp,zeit_calc_l	;neue gerechnete Zeit
	lds	temp1,zeit_calc_h	;
	sts	zeit_anz_l,temp		;geht aufs Display
	sts	zeit_anz_h,temp1	;
	ret				;

;*********************************************************************************************************
;***************  fhre die Quarzzeit an den gerechneten Wert heran				**********
;***************  wenn noch nicht synchron, in einem Ruck, sonst sukzessive			**********
;***************  ich kann dazu das Uhrwerk auf Frameebene in BEIDE Richtungen schieben		**********
;***************  das ist nicht sauber gelst, da damit auch die Zeitbasis der ganzen		**********
;***************  Anwendung beeinflusst wird							**********
;***************  benutzte Register: zeit_anz, temp[3:0], zeit_calc, frame			**********
;*********************************************************************************************************
synchronisiere_zeit:
	lds	temp2,zeit_anz_l	;hole die Laufzeit in der Anzeige
	lds	temp3,zeit_anz_h	;
	subi	temp2,byte1(-1)		;eine quarzgenaue Sekunde mehr bitte
	sbci	temp3,byte2(-1)		;und diese neue Zeit erstmal nur merken
	sbrs	flags2,synchron		;bis zur Synchronisierung
	rjmp	sync_zeit		;stur die Quarzzeit zhlen
	lds	temp,zeit_calc_l	;
	lds	temp1,zeit_calc_h	;hole die errechnete Laufzeit

	cp	temp2,temp		;Zeit im Display vorsichtig an errechnete Zeit
	cpc	temp3,temp1		;heranfhren
	breq	sync_zeit		;sehr gut keine Abweichung
	brlo	zu_langsam		;
zu_schnell:
	ldi	temp,frameoffset-ziehrate
	sts	frame,temp		;verzgere den nchsten Sekundenwechsel etwas
	rjmp	sync_zeit		;
zu_langsam:
	ldi	temp,frameoffset+ziehrate
	sts	frame,temp		;ziehe den nchsten Sekundenwechsel etwas vor
sync_zeit:
	sts	zeit_anz_l,temp2	;und raus aufs Display
	sts	zeit_anz_h,temp3	;
	ret				;

;*********************************************************************************************************
;***************  einen Punkt (entspricht dem Messraster, z.Zt. 4 Sekunden)			**********
;***************  auf die Betriebsstunden draufzhlen						**********
;***************  benutzte Register: temp[2:0] Stunden[2:0]					**********
;*********************************************************************************************************
addiere_kopfzeit:
	lds	temp,stunden_0		;hole Betriebsstunden
	lds	temp1,stunden_1		;
	lds	temp2,stunden_2		;
	ldi	temp3,1			;1 Tick = "Kopfstundenintervall" Sekunden draufgeben
	add	temp,temp3		;
	adc	temp1,null		;
	adc	temp2,null		;
	sts	stunden_0,temp		;wieder weglegen
	sts	stunden_1,temp1		;
	sts	stunden_2,temp2		;
	ret				;

;*********************************************************************************************************
;***************  Den Inhalt Betriebsstundenzhler in echte Stunden umrechnen			**********
;***************  und fr die Darstellung im Display bereithalten				**********
;***************  Kopfstunden = Stundenzhler*kopfintervall/3600				**********
;***************  umgeformt zu: Stundenzhler*kopfintervall*1165/2^22				**********
;***************  benutzte Register: var[2:0], Stunden[2:0], var2[2:0]				**********
;*********************************************************************************************************
rechne_betriebsstunden:
	lds	var20,stunden_0		;lade Dividend "Betriebsstundenzhler"
	lds	var21,stunden_1		;
	lds	var22,stunden_2		;

	ldi	var10,byte1(kopfintervall*1165)	;lade Divisor
	ldi	var11,byte2(kopfintervall*1165)	;K = 2^22/3600

	rcall	mul16x24u		;und wandle

	lsl	mod2			;*2
	rol	mod3			;
	rol	mod4			;

	lsl	mod2			;*4
	rol	mod3			;
	rol	mod4			;

	sts	hour_l,mod3		;zur Anzeige von vollen Stunden im Display
	sts	hour_h,mod4		;
	ret				;

;*********************************************************************************************************
;***************  sichere Zhlerstnde ins EEPROM: Segmentlaufzeit, dicke, Bandlagen	**********
;***************  Betriebsstunden								**********
;***************  benutzte Register: temp[1:0], t_segm[H:L], dicke[H:L], Lagen[H:L]		**********
;***************		     stunden[3:1]						**********
;*********************************************************************************************************
rette_werte:
	cli				;keine ISR mehr ausfhren
	sbi	portc,a_ir_led		;IR-LEDs abschalten spart Strom
	sbi	portb,a_LED		;Debug-LED aus
	rcall	anzeige_aus		;Display abschalten

	sbis	pinb,e_taster		;wenn Taster beim Ausschalten gedrckt ist
	rcall	loesche_betriebsstunden	;Kopfstundenzhler lschen

	ldi	temp1,adr_eeprom+0	;setze EEPROM-Adresse
	lds	temp,stunden_0		;sichere Betriebsstunden
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+1	;
	lds	temp,stunden_1		;
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+2	;
	lds	temp,stunden_2		;
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+3	;
	lds	temp,umdreh_l		;sichere Umdrehungen
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+4	;
	lds	temp,umdreh_h		;
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+5	;
	lds	temp,dicke_l		;sichere Dickenwert
	rcall	eewrite3		;
	ldi	temp1,adr_eeprom+6	;
	lds	temp,dicke_h		;
	rcall	eewrite3		;

	cbi	portb,a_LED		;LED an
	rjmp	PC-1			;bis der Strom ganz weg ist
	ret				;

;*********************************************************************************************************
;***************  Anzeige abschalten								**********
;***************  benutzte Register: temp, portc, portd						**********
;*********************************************************************************************************
anzeige_aus:
.if (Anzeigeart==1)
	ser	temp			;schalte
.else
	clr	temp			;schalte
.endif
	out	portd,temp		;alle Segmente ab
	in	temp,portc		;sichere Portstatus
.if (Anzeigeart!=1)
	andi	temp,(1<<A_IR_LED)	;maskiere IR-LED-Ausgang aus und
.else
	ori	temp,~(1<<A_IR_LED)	;maskiere IR-LED-Ausgang aus und
.endif
	out	portc,temp		;schalte alle Anzeigestellen ab
	ret

;*********************************************************************************************************
;***************  Den Betriebsstundenzhler auf 0 setzen					**********
;***************  benutzte Register: temp, Stunden[2:0]						**********
;*********************************************************************************************************
loesche_betriebsstunden:
	clr	temp			;
	sts	stunden_0,temp		;
	sts	stunden_1,temp		;
	sts	stunden_2,temp		;
	ret				;

;*********************************************************************************************************
;***************  SRAM bis Zelle 224 lschen							**********
;***************  benutzte Register: temp, Z							**********
;*********************************************************************************************************
loesche_sram:
	clr	temp
	clr	zh			;Zeiger auf Beginn
	ldi	zl,0x0060		;SRAM-Bereich einstellen
clr_ram:
	st	z+,temp			;und lschen
	st	z+,temp			;
	st	z+,temp			;
	st	z+,temp			;
	st	z+,temp			;und lschen
	st	z+,temp			;
	st	z+,temp			;
	st	z+,temp			;
	cpi	zl,byte1(ramend-16)	;den Stackpointerbereich grozgig aussparen
	ldi	temp2,byte2(ramend-16)	;hilft Probleme zu vermeiden :-)
	cpc	zh,temp2		;
	brlo	clr_ram			;
	ret				;

;*********************************************************************************************************
;***************  Defaultwert des Kernradius fr die Berechnungen laden			**********
;***************  benutzte Register: temp, Kernradius[2:0]				**********
;*********************************************************************************************************
init_Kernradius:
	ldi	temp,byte1(wickelkern*100)	;Default-Radius des leeren Wickeltellers * 100
	sts	Kernradius_0,temp		;fr Rechnungen vorhalten
	ldi	temp,byte2(wickelkern*100)	;
	sts	Kernradius_1,temp		;
	ldi	temp,byte3(wickelkern*100)	;
	sts	Kernradius_2,temp		;
	ret					;

;*********************************************************************************************************
;***************  Ringspeicher V Wickelgeschwindigkeit derart mit absteigenden Werten fllen,	**********
;***************  dass sich aus dem Speicherinhalt die aktuelle Dicke ergibt und dass		**********
;***************  durch das Einlaufen von frischen Werten keine grossen Abweichungen entstehen	**********
;***************  Pro Umdrehung verlangsamt sich die Tellergeschwindigkeit um den Faktor:	**********
;***************  Delta T-Segm = Banddicke * 2 * Pi * CLK/(Vo * zebra * Vorteiler1)		**********
;***************  pro halber Umdrehung um:							**********
;***************  Delta T-Segm = dickenwert * Pi * CLK/(Vo * zebra * Vorteiler1 * 100000)	**********
;***************  Umgeformt zu: Delta T-Segm von 0,5 Umdr = Dickenwert * (693515/zebra) / 2^24	**********
;***************  benutzte Register: temp[3:0], var1[1:0], var2[3:0], mod[3:0], Z		**********
;*********************************************************************************************************
init_speicher_v:
	mov	temp2,var22		;lade Eingangswert um,
	mov	temp3,var23		;weil var22:var23 gleich zerstrt wird

	lds	var10,dicke_l		;hole Dickenwert
	lds	var11,dicke_h		;

	subi	var10,byte1(zebra*Bandgeschw/3927)	;hier Runden
	sbci	var11,byte2(zebra*Bandgeschw/3927)	;K = 2 * Pi * CLK/Teiler1 * 100

	ldi	var20,byte1(693516/zebra)		;lade Multiplikator
	ldi	var21,byte2(693516/zebra)		;K = Pi*CLK*2^24/(Vo*Vorteiler1*100000)
	ldi	var22,byte3(693516/zebra)		;

	rcall	mul16x24u		;rechne: "dicke * 87064" und dividieren durch 2^24
					;durch Weglassen der unteren 3 Byte, der Nachkommastellen!
	lsr	mod2			;die hchsten 8 binren Nachkommastellen werden genutzt,
	lsr	mod2			;indem ich einem Wert pro Umdrehung die
	lsr	mod2			;"zebra"-fachen Nachkommastellen dazuaddiere
	lsr	mod2			;
	lsr	mod2			;8-fach
.if (zebra!=8)
	lsr	mod2			;4-fach
.endif
	ldi	zh,byte2(speicher_v+(zebra*2))	;Zeiger auf Speicherbereich V 
	ldi	zl,byte1(speicher_v+(zebra*2))	;2te Umdrehung stellen
init_v:
	sub	temp2,mod3		;rechne: "T-Segm - dicke * 87064 / 2^24"
	sbc	temp3,mod4		;ergibt die Werte T-Segm fr die nchste halbe Umdrehung

	st	z+,temp2		;
	st	z+,temp3		;
	st	z+,temp2		;
	st	z+,temp3		;
.if (zebra==8)
	st	z+,temp2		;
	st	z+,temp3		;
	st	z+,temp2		;
	st	z+,temp3		;
.endif
;die nchste halbe Umdrehung
	sub	temp2,mod3		; "T-Segm - dicke * 87064 / 2^24"
	sbc	temp3,mod4		;ergibt die 4 Werte T-Segm fr die nchste halbe Umdrehung
.if (zebra==8)
	st	z+,temp2		;
	st	z+,temp3		;
	st	z+,temp2		;
	st	z+,temp3		;
.endif
	st	z+,temp2		;
	st	z+,temp3		;

	add	temp2,mod2		;Nachkommastellen nach einer Umdrehung bercksichtigen
	adc	temp3,null		;

	st	z+,temp2		;
	st	z+,temp3		;

	sub	temp2,mod2		;temp2 und temp3 wiederherstellen
	sbc	temp3,null		;

	cpi	zl,byte1(speicher_v+(2*zebra*(Mittelwerttiefe+Delta_v)))
	ldi	temp,byte2(speicher_v+(2*zebra*(Mittelwerttiefe+Delta_v)))
	cpc	zh,temp			;
	brlo	init_v			;ganzer Speicher voll?
	ret				;
	
;*********************************************************************************************************
;***************  Mittelwertspeicher U (Dickenwert) mit dem Wert temp[1:0] fllen		**********
;***************  benutzte Register: temp[2:0], dicke[H:L:F]					**********
;*********************************************************************************************************
init_speicher_u:
	clr	temp2			;
	sts	dicke_f,temp2		;
	sts	dicke_l,temp		;
	sts	dicke_h,temp1		;
	ret				;
	
;*********************************************************************************************************
;***************  wenn der Taster beim Einschalten gedrckt ist wird				**********
;***************  folgende Aktion ausgefhrt:							**********
;***************  benutzte Register:								**********
;*********************************************************************************************************
irgendwas:
	nop				;mache noch nichts
	nop				;wirklich nicht!
	ret				;

;*********************************************************************************************************
;***************  Daten aus temp ins EEPROM auf Adresse in temp1 schreiben			**********
;***************  benutzte Register: temp, null:temp1, EEARL, EEARH, EECR, EEDR			**********
;*********************************************************************************************************
eewrite:
	sbic	EECR,EEWE		;ist das EEPROM empfangsbereit ?
	rjmp	eewrite			;nein, warte noch
	out	EEARH,null		;die oberen 256 Byte nicht anfassen
	out	EEARL,temp1		;EEPROM-Adresse setzen,
	out	EEDR,temp		;Daten ins Schreibregister holen
	sbi	EECR,EEMWE		;MasterWriteEnable setzen
	sbi	EECR,EEWE		;und strobe EEPROM
	ret				;fertig

;*********************************************************************************************************
;***************  Daten in temp als Tripel mit 80 Zellen Abstand ins EEPROM schreiben		**********
;***************  anfangend mit Adresse aus temp1						**********
;***************  benutzte Register: temp, null:temp1, EEARL, EEARH, EECR, EEDR			**********
;*********************************************************************************************************
eewrite3:
	rcall	eewrite			;schreibe auf Adresse A
	subi	temp1,-80		;
	rcall	eewrite			;und B (A + 80)
	subi	temp1,-80		;
	rcall	eewrite			;und C (A + 160)
	subi	temp1,160		;Einstiegsadresse temp1 wieder herstellen
	ret				;

;*********************************************************************************************************
;***************  Daten aus dem EEPROM von Adresse temp1 holen					**********
;***************  und in temp zur Weiterverarbeitung bereithalten				**********
;***************  benutzte Register: temp, null:temp1, EEARL, EEARH, EECR, EEDR			**********
;*********************************************************************************************************
eeread:	
	sbic	EECR,EEWE		;wenn das EEPROM mit Schreiben beschftigt,
	rjmp	eeread			;warten
	out	EEARH,null		;die oberen 256 Byte nicht anfassen
	out	EEARL,temp1		;sende Adresse
	sbi	EECR,EERE		;strobe EEPROM
	in	temp,EEDR		;dann stehen die Daten in temp bereit
	ret				;

;*********************************************************************************************************
;***************  EEPROM auf korrupte Zellen hin absuchen und Reparaturen durchfhren		**********
;***************  dazu ist es in 3 gleiche Bereiche aufgeteilt, in denen die Daten		**********
;***************  von allen Prozessen redundant als Tripel abgelegt wurden			**********
;***************  benutzte Register: temp, null:temp1, adr, A, B, C				**********
;*********************************************************************************************************
teste_eeprom:
	clr	adr			;setze Adresse auf 0
new_tripel:
	inc	adr			;nchste Adresse
	mov	temp1,adr		;sichere Adresse
	cpi	temp1,80		;schon bei der 81sten Zelle angekommen
	brsh	end_korr		;dann fertig und raus

	rcall	eeread			;
	mov	A,temp			;hole Daten A
	subi	temp1,-80		;setze Adresse fr B (80 Zellen hher)
	rcall	eeread			;
	mov	B,temp			;hole Daten B
	subi	temp1,-80		;setze Adresse fr C (noch 80 Zellen hher)
	rcall	eeread			;
	mov	C,temp			;hole Daten C

	cpse	A,B			;A = B ?
	rjmp	BundC			;nein

	cp	A,C			;A = C ?
	breq	new_tripel		;keine Korruption, nchstes Tripel holen
	mov	temp2,A			;C defekt, hole Daten A(=B)
	rcall	eewrite			;und repariere C
	rjmp	new_tripel		;Daten repariert, nchstes Tripel holen

BundC:	cpse	B,C			;B = C ?
	rjmp	AundC			;nein
	mov	temp2,B			;A defekt, hole Daten B(=C)
	subi	temp1,160		;lade Adresse A
	rcall	eewrite			;und repariere A
	rjmp	new_tripel		;Daten repariert, nchstes Tripel holen

AundC:	cpse	A,C			;A = C ?	
	rjmp	ABCdef			;nein
	mov	temp2,C			;B defekt, hole Daten C(=A)
	subi	temp1,80		;lade Adresse B
	rcall	eewrite			;und repariere B
	rjmp	new_tripel		;Daten repariert, nchste Adresse holen

ABCdef:	mov	temp2,A			;alle Daten unterschiedlich, hole Daten A
	rcall	eewrite			;und repariere damit C
	subi	temp1,80		;und auf Adresse B
	rcall	eewrite			;auch B
	rjmp	new_tripel		;nchstes Tripel holen
end_korr:
	ret				;

;*********************************************************************************************************
;***************  EEPROM initialisieren								**********
;***************  ein fabrikfrisches EEPROM wird gelscht					**********
;***************  benutzte Register: temp, null:temp1, EEARL, EEARH, EECR, EEDR			**********
;*********************************************************************************************************
init_eeprom:
	clr	temp			;schreibe 00 in die Zellen
	clr	temp1			;fang bei Adresse 0 an
initee:
	rcall	eewrite			;bitte
	inc	temp1			;nchste Adresse
	tst	temp1			;schon am Ende des genutzten Bereiches angekommen ?
	brne	initee			;nein,

	ldi	temp,byte1(def_stunden*3600/Kopfintervall);Kopfstunden
	ldi	temp1,adr_eeprom+0	;
	rcall	eewrite3		;
	ldi	temp,byte2(def_stunden*3600/Kopfintervall)
	ldi	temp1,adr_eeprom+1	;
	rcall	eewrite3		;
	ldi	temp,byte3(def_stunden*3600/Kopfintervall)
	ldi	temp1,adr_eeprom+2	;
	rcall	eewrite3		;

	ldi	temp,byte1(def_dicke/10);einen Dickenwert
	ldi	temp1,adr_eeprom+5	;
	rcall	eewrite3		;
	ldi	temp,byte2(def_dicke/10);
	ldi	temp1,adr_eeprom+6	;
	rcall	eewrite3		;

	ldi	temp1,1			;vermerke die Initialisierung nun in Zelle Nr. 1
	ldi	temp,0b10110100		;mit einem Bitmuster
	rcall	eewrite3		;
	ret				;fertig
